#version 450
#extension GL_EXT_debug_printf : enable

layout(binding = 0) uniform UniformBufferObject {
    mat4 model;
    mat4 view;
    mat4 proj;
} ubo;

layout(location = 0) in vec3 inPosition;
layout(location = 1) in vec3 inColor;
layout(location = 2) in vec2 inTextureCoordinate;

layout(location = 0) out vec3 fragColor;
layout(location = 1) out vec2 fragTextureCoordinate;


void main() {
    gl_Position = ubo.proj * ubo.view * ubo.model * vec4(inPosition, 1.0);
    /* gl_Position = vec4(inPosition, 1.0); */

    /* debugPrintfEXT("inPosition %v3f, inColor %v3f", inPosition, inColor); */
    fragColor = inColor;
    fragTextureCoordinate = inTextureCoordinate;
}
